/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.kickstone.pricegoblin.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.ColumnResult;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedNativeQueries;
import javax.persistence.NamedNativeQuery;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SqlResultSetMapping;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import org.codehaus.jackson.annotate.JsonAutoDetect;
import org.codehaus.jackson.annotate.JsonMethod;
import org.codehaus.jackson.annotate.JsonProperty;

/**
 *
 * @author john
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.NONE)
@JsonAutoDetect(JsonMethod.NONE)
@Entity
@Table(name = "retailer_retailer", schema = "django")
@SqlResultSetMapping(name="map_mapping",
    columns = {
        @ColumnResult(name = "offer_id")
    }
)
@NamedQueries({
    @NamedQuery(name = "Retailer.findByExternalUri", query = "SELECT r FROM Retailer r WHERE r.externalUri = :externalUri")
})
@NamedNativeQueries({
    @NamedNativeQuery(name = "SummaryMap.findOffer", query = "SELECT offer_id FROM django.summary_map WHERE template=? AND LOWER(value)=? AND position = ?", resultSetMapping="map_mapping")
})
public class Retailer implements Serializable {
    private static final long serialVersionUID = 1L;
    
    @Id
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;

    @Basic(optional = false)
    @Column(name = "date_created")
//    @Temporal(TemporalType.TIMESTAMP)
    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
    private Date dateCreated;

    @Basic(optional = false)
    @Column(name = "last_modified")
    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
//    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModified;

    @Basic(optional = false)
    @Column(name = "external_uri")
    private String externalUri;

    @Basic(optional = false)
    @Column(name = "name")
    private String name;

    @Basic(optional = false)
    @Column(name = "description")
    private String description;

    public Retailer() {
    }

    public Retailer(Integer id) {
        this.id = id;
    }

    public Retailer(Integer id, String externalUri, String name, String description) {
        this.id = id;
        this.dateCreated = new Date(System.currentTimeMillis());
        this.lastModified = new Date(System.currentTimeMillis());
        this.externalUri = externalUri;
        this.name = name;
        this.description = description;
    }

    public Integer getId() {
        return id;
    }

    public Date getDateCreated() {
        return dateCreated;
    }

    public Date getLastModified() {
        return lastModified;
    }

    public String getExternalUri() {
        return externalUri;
    }

    public void setExternalUri(String externalUri) {
        this.lastModified = new Date(System.currentTimeMillis());
        this.externalUri = externalUri;
    }

    @JsonProperty("name")
    @XmlElement(name="name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.lastModified = new Date(System.currentTimeMillis());
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.lastModified = new Date(System.currentTimeMillis());
        this.description = description;
    }

    @JsonProperty("uri")
    @XmlElement(name="uri")
    public String getUri(){
        return String.format("/retailer/%09d/",id);
    }


    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Retailer)) {
            return false;
        }
        Retailer other = (Retailer) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entity.Retailer[id=" + id + "]";
    }

}
